<?php

function buildBaseString($baseURI, $method, $params){
    $r = array(); ksort($params); 
    foreach($params as $key=>$value) $r[] = "$key=" . rawurlencode($value); 
              
    return $method."&" . rawurlencode($baseURI) . '&' . rawurlencode(implode('&', $r)); //return complete base string  
}

function buildAuthorizationHeader($oauth){
    $r = "Authorization: OAuth ";
    $values = array();
    
    foreach($oauth as $key=>$value) $values[] = "$key=\"" . rawurlencode($value) . "\""; 
    
    $r .= implode(", ", $values); 
    
   	return $r; 
}

function twitter_request($url,$request,$jsonformat=0){

	$oauth_access_token = "YOUR TOKEN HERE";
	$oauth_access_token_secret = "YOUR TOKEN SECRET HERE";
	$consumer_key = "YOUR KEY HERE";
	$consumer_secret = "YOUR SECRET HERE";
			
	$now=time();
	
	$oauth = array( 'oauth_consumer_key' => $consumer_key,
	                'oauth_nonce' => $now,
	                'oauth_signature_method' => 'HMAC-SHA1',
	                'oauth_token' => $oauth_access_token,
	                'oauth_timestamp' => $now,
	                'oauth_version' => '1.0',
	                );
	                
	                
	                
	$oauth = array_merge($oauth, $request);                
	
	$base_info = buildBaseString($url, 'GET', $oauth);
	$composite_key = rawurlencode($consumer_secret) . '&' . rawurlencode($oauth_access_token_secret);
	$oauth_signature = base64_encode(hash_hmac('sha1', $base_info, $composite_key, true));
	$oauth['oauth_signature'] = $oauth_signature;
	
	
	$header = array(buildAuthorizationHeader($oauth), 'Expect:');
	$options = array( CURLOPT_HTTPHEADER => $header,
	                  CURLOPT_URL => $url.'?'.http_build_query($request),
	                  CURLOPT_RETURNTRANSFER => 1, CURLOPT_SSL_VERIFYPEER => 0);
	
	                  
	$curl = curl_init();
	curl_setopt_array($curl, $options);
	$json = curl_exec($curl);
	curl_close($curl);
	
	$res = json_decode($json);
	
	return $jsonformat?$json:$res;
}

/*

//$url="https://api.twitter.com/1.1/statuses/user_timeline.json";

$request = array(                
                'q'=>'antradar',
                'result_type'=>'mixed',
                'count'=>1,
                );


$res=twitter_request("https://api.twitter.com/1.1/search/tweets.json",$request,true);
                
print_r($res);

*/
